#include "GPUFontLayer.h"
#include "Atlas.h"
#include "Utils.h"
#include "fwd.hpp"
#include "ofGraphics.h"
#include "ofUtils.h"

namespace ofxVariableLab {

void GPUFontLayer::setup(const LayerSettings & settings){
    this->settings = settings;
    if(id == ""){
        id = ofToString(Layer::n_layers);
        n_layers++;
    }
}

void GPUFontLayer::update(){
    if(isDirty){
        isDirty = false;
    }
}

void GPUFontLayer::draw(glm::vec3 position){
}
void GPUFontLayer::drawCharacter(const char character,
                                 glm::vec3 position,
                                 glm::vec4 color,
                                 float rotation,
                                 float scale,
                                 ofxVariableLab::FontVariation fontVariation){
}
const Layer::Type & GPUFontLayer::getType() const {
    return type;
}
void GPUFontLayer::setVFlip(const VFlipState vFlip){
    this->vFlip = vFlip;
}

//void GPUFontLayer::setAtlas(shared_ptr <ofxGPUFont::Atlas> _atlas){
//atlas = _atlas;
//// TODO: this does not seem proper
//propsBuffer[0].fontSize_px = atlas->settings.scale;
//}
//shared_ptr <ofxGPUFont::Atlas> GPUFontLayer::getAtlas() const {
//return atlas;
//}
void GPUFontLayer::setProps(const Props & props){
    while(propsBuffer.size() > max(0, int(settings.maxBufferSize - 1))){
        propsBuffer.pop_back();
    }
    propsBuffer.push_front(props);
}
const Layer::Props & GPUFontLayer::getProps() const {
    return propsBuffer[0];
}
void GPUFontLayer::clearPropsBuffer(){
    propsBuffer.clear();
}
void GPUFontLayer::setId(const LayerID & id){
    this->id = id;
}
const LayerID & GPUFontLayer::getId(){
    return id;
}
}
